#include <bits/stdc++.h>
using namespace std;

#define nl "\n"
#define nf endl
#define ll long long
#define pb push_back
#define _ << ' ' <<

#define INF (ll)1e18

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    // ifstream cin("input.txt");

    ll n, m; cin >> n >> m;
    vector<vector<ll>> adj(n + 1);
    for (ll i = 1; i <= m; i++) {
        ll a, b; cin >> a >> b;
        adj[a].pb(b); adj[b].pb(a);
    }

    auto bfs = [&](ll start) {
        queue<ll> q;
        vector<ll> dist(n + 1, INF);
        dist[start] = 0; q.push(start);

        while (!q.empty()) {
            auto s = q.front(); q.pop();
            for (auto u : adj[s]) {
                if (dist[u] != INF) continue;
                dist[u] = dist[s] + 1; q.push(u);
            }
        }

        return dist;
    };

    vector<ll> to_n = bfs(n);
    vector<ll> worst(n + 1, INF);
    for (ll i = 1; i <= n; i++) {
        vector<ll> close;
        for (auto u : adj[i]) close.pb(to_n[i]);
        sort(close.begin(), close.end());
        if (close.size() <= 1) continue;
        for (auto u : close) cout << u << ' ';
        cout << nl;
        worst[i] = close[1];
    }

    for (ll i = 1; i <= n; i++) cout << to_n[i] << ' ';
    cout << nf;
    for (ll i = 1; i <= n; i++) cout << worst[i] << ' ';
    cout << nf;

    auto reachable = [&](ll bsm) {
        ll start = 1;
        queue<ll> q;
        vector<ll> dist(n + 1, INF);
        dist[start] = 0; q.push(start);

        while (!q.empty()) {
            auto s = q.front(); q.pop();
            for (auto u : adj[s]) {
                if (dist[u] != INF) continue;
                if (dist[s] + 1 + worst[u] > bsm) continue;
                dist[u] = dist[s] + 1; q.push(u);
            }
        }

        return (dist[n] <= bsm);
    };

    ll bsl = 0, bsu = n + 5;
    while (bsl != bsu) {
        ll bsm = (bsl + bsu) / 2;
        if (reachable(bsm)) bsu = bsm;
        else bsl = bsm + 1; 
    }

    cout << bsl << nl;
}